# API Reference <a name="API Reference"></a>

## Constructs <a name="Constructs"></a>

### CompliantDynamoDb <a name="compliantdynamodb.CompliantDynamoDb"></a>

Creates a DynamoDB table that is secured by an AWS backup plan und with point in time recovery enabled by default.

#### Initializers <a name="compliantdynamodb.CompliantDynamoDb.Initializer"></a>

```typescript
import { CompliantDynamoDb } from 'compliantdynamodb'

new CompliantDynamoDb(scope: Construct, id: string, props?: ICompliantDynamoDbProps)
```

##### `scope`<sup>Required</sup> <a name="compliantdynamodb.CompliantDynamoDb.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="compliantdynamodb.CompliantDynamoDb.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Optional</sup> <a name="compliantdynamodb.CompliantDynamoDb.parameter.props"></a>

- *Type:* [`compliantdynamodb.ICompliantDynamoDbProps`](#compliantdynamodb.ICompliantDynamoDbProps)

---



#### Properties <a name="Properties"></a>

##### `dynamodbTable`<sup>Required</sup> <a name="compliantdynamodb.CompliantDynamoDb.property.dynamodbTable"></a>

```typescript
public readonly dynamodbTable: Table;
```

- *Type:* [`@aws-cdk/aws-dynamodb.Table`](#@aws-cdk/aws-dynamodb.Table)

---




## Protocols <a name="Protocols"></a>

### ICompliantDynamoDbProps <a name="compliantdynamodb.ICompliantDynamoDbProps"></a>

- *Implemented By:* [`compliantdynamodb.ICompliantDynamoDbProps`](#compliantdynamodb.ICompliantDynamoDbProps)


#### Properties <a name="Properties"></a>

##### `backupPlanStartTime`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.backupPlanStartTime"></a>

```typescript
public readonly backupPlanStartTime: Schedule;
```

- *Type:* [`@aws-cdk/aws-events.Schedule`](#@aws-cdk/aws-events.Schedule)

---

##### `backupVaultName`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.backupVaultName"></a>

```typescript
public readonly backupVaultName: string;
```

- *Type:* `string`

---

##### `contributorInsightsEnabled`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.contributorInsightsEnabled"></a>

```typescript
public readonly contributorInsightsEnabled: boolean;
```

- *Type:* `boolean`

---

##### `encryptionKey`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: Key;
```

- *Type:* [`@aws-cdk/aws-kms.Key`](#@aws-cdk/aws-kms.Key)

---

##### `kinesisStream`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.kinesisStream"></a>

```typescript
public readonly kinesisStream: Stream;
```

- *Type:* [`@aws-cdk/aws-kinesis.Stream`](#@aws-cdk/aws-kinesis.Stream)

---

##### `partitionKey`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.partitionKey"></a>

```typescript
public readonly partitionKey: Attribute;
```

- *Type:* [`@aws-cdk/aws-dynamodb.Attribute`](#@aws-cdk/aws-dynamodb.Attribute)

---

##### `replicationRegions`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.replicationRegions"></a>

```typescript
public readonly replicationRegions: string[];
```

- *Type:* `string`[]

---

##### `replicationTimeout`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.replicationTimeout"></a>

```typescript
public readonly replicationTimeout: Duration;
```

- *Type:* [`@aws-cdk/core.Duration`](#@aws-cdk/core.Duration)

---

##### `sortKey`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.sortKey"></a>

```typescript
public readonly sortKey: Attribute;
```

- *Type:* [`@aws-cdk/aws-dynamodb.Attribute`](#@aws-cdk/aws-dynamodb.Attribute)

---

##### `tableName`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* `string`

---

##### `timeToLiveAttribute`<sup>Optional</sup> <a name="compliantdynamodb.ICompliantDynamoDbProps.property.timeToLiveAttribute"></a>

```typescript
public readonly timeToLiveAttribute: string;
```

- *Type:* `string`

---

